# $Id: Tool.py,v 1.3 2005/03/27 17:43:43 asc Exp $

__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/ImageWidgetDeliciousTools/"
__version__    = "1.0"
__cvsversion__ = "$Revision: 1.3 $"
__date__       = "$Date: 2005/03/27 17:43:43 $"
__copyright__  = "Copyright (c) 2005 Aaron Straup Cope."
__license__    = "GNU GPL 2"

import wx
import delicious

from ImageWidget.Login import ImageWidgetLogin
from ImageWidgetDeliciousTool.Constants import *

class DeliciousTool :

    def Setup (self,frame) :
	DelMenu = wx.Menu()

	DelMenu.Append(DELICIOUS_ID_POST,
		       DELICIOUS_MENU_POST,
		       DELICIOUS_DESCRIBE_POST)

	DelMenu.Append(DELICIOUS_ID_EDITLOGIN,
		       DELICIOUS_MENU_EDITLOGIN,
		       DELICIOUS_DESCRIBE_EDITLOGIN)

	wx.EVT_MENU(frame,DELICIOUS_ID_POST,
		    self.PostToDelicious);

	wx.EVT_MENU(frame,
		    DELICIOUS_ID_EDITLOGIN,
		    self.EditDeliciousLogin);

	menu  = frame.GetMenuBar();
	menu.Append(DelMenu,DELICIOUS_MENU_LABEL)

	#

	cfg = self.Config()
	ns  = cfg.nsCustom(DELICIOUS_NAMESPACE)

	cfg.EnsureStubProperty(ns[DELICIOUS_CFG_USERNAME])
	cfg.EnsureStubProperty(ns[DELICIOUS_CFG_PASSWORD])
	
    #

    def DeliciousKeyDown (self,key,event=None) :

	if key == "D" :

	    if event==None:
		return True

	    if event.ShiftDown() :
		self.EditDeliciousLogin()
	    else :
		self.PostToDelicious(event)	
	else :
	    return False

    #

    def DeliciousTags (self) :
	return ""

    # FIX ME : allow user defined title strings

    def PostToDelicious (self,event,fmt=u"[%s] %s") :

	try :
	    photo = self.GetCurrentPhoto()
	except Exception, e:
	    self.ReportError(e.toString())
	    return False

	# User info

	[user,pswd] = self.GetDeliciousLogin()

	if ((user==u"") or (pswd==u"")) :
	    [user,pswd] = self.EditDeliciousLogin()

	#

	title = fmt % (photo['creator'],photo['title']);
	tags  = self.DeliciousTags()

	try :
	    delicious.add(user,pswd,photo['url'],title,'',tags);
	    self.ReportActivity(DELICIOUS_MSG_POSTED);
	except Exception, e :
	    self.ReportError(DELICIOUS_MSG_NOTPOSTED % e);

    #

    def GetDeliciousLogin (self) :
	cfg = self.Config()
	ns  = cfg.nsCustom(DELICIOUS_NAMESPACE)

	user = cfg.GetPref(ns[DELICIOUS_CFG_USERNAME])
	pswd = cfg.GetPref(ns[DELICIOUS_CFG_PASSWORD])

	return [user,pswd]

    #

    def EditDeliciousLogin (self,event=None) :

	[user,pswd] = self.GetDeliciousLogin()

	frame = self.GetTopWindow()
	auth  = ImageWidgetLogin(frame,-1,DELICIOUS_LOGIN_TITLE,user,pswd)

	(x,y) = frame.GetPosition()
	auth.SetPosition((x + 50,y + 50))
	    
	auth.ShowModal()
	input = auth.result
	
	if input :
		
	    user = input['user']
	    pswd = input['pswd']
		
	    if input['save'] :
		cfg = self.Config()
		ns  = cfg.nsCustom(DELICIOUS_NAMESPACE)

		cfg.SetPref(ns[DELICIOUS_CFG_USERNAME],user)
		cfg.SetPref(ns[DELICIOUS_CFG_PASSWORD],pswd)
		cfg.Save()
		    
	auth.Destroy()
	return [user,pswd]
